import * as tslib_1 from "tslib";
import { Component, Input, Output, EventEmitter } from '@angular/core';
import * as common from 'file-uploader-component';
import { indexTemplateHtml } from './variables';
/**
 * @public
 */
var FileUploaderComponent = /** @class */ (function () {
    function FileUploaderComponent() {
        this.fileGot = new EventEmitter();
        this.fileUploaded = new EventEmitter();
        this.requests = [];
    }
    Object.defineProperty(FileUploaderComponent.prototype, "localeObject", {
        get: function () {
            return common.getLocale(this.locale);
        },
        enumerable: true,
        configurable: true
    });
    FileUploaderComponent.prototype.onDrop = function (e) {
        var _this = this;
        common.onDrop(e, this.name, this.url, this.method, function (file) {
            _this.fileGot.emit(file);
        }, function (request) {
            _this.fileUploaded.emit(request.response);
            common.removeRequest(_this.requests, request);
        }, function (percent) {
            // nothing to do
        }, function (request) {
            _this.requests.push(request);
        });
    };
    FileUploaderComponent.prototype.onPaste = function (e) {
        var _this = this;
        common.onPaste(e, this.name, this.url, this.method, function (file) {
            _this.fileGot.emit(file);
        }, function (request) {
            _this.fileUploaded.emit(request.response);
            common.removeRequest(_this.requests, request);
        }, function (percent) {
            // nothing to do
        }, function (request) {
            _this.requests.push(request);
        });
    };
    FileUploaderComponent.prototype.onFileUploaded = function (e) {
        var _this = this;
        common.onFileUploaded(e, this.name, this.url, this.method, function (file) {
            _this.fileGot.emit(file);
        }, function (request) {
            _this.fileUploaded.emit(request.response);
            common.removeRequest(_this.requests, request);
        }, function (percent) {
            // nothing to do
        }, function (request) {
            _this.requests.push(request);
        });
    };
    FileUploaderComponent.prototype.trackBy = function (request, index) {
        return index;
    };
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String)
    ], FileUploaderComponent.prototype, "accept", void 0);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Boolean)
    ], FileUploaderComponent.prototype, "multiple", void 0);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Object)
    ], FileUploaderComponent.prototype, "locale", void 0);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String)
    ], FileUploaderComponent.prototype, "name", void 0);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String)
    ], FileUploaderComponent.prototype, "url", void 0);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", String)
    ], FileUploaderComponent.prototype, "method", void 0);
    tslib_1.__decorate([
        Output(),
        tslib_1.__metadata("design:type", Object)
    ], FileUploaderComponent.prototype, "fileGot", void 0);
    tslib_1.__decorate([
        Output(),
        tslib_1.__metadata("design:type", Object)
    ], FileUploaderComponent.prototype, "fileUploaded", void 0);
    FileUploaderComponent = tslib_1.__decorate([
        Component({
            selector: 'file-uploader',
            template: indexTemplateHtml
        })
    ], FileUploaderComponent);
    return FileUploaderComponent;
}());
export { FileUploaderComponent };
